<?php

namespace App\Filament\Exports;

use App\Models\ProductionOrder;
use Filament\Actions\Exports\ExportColumn;
use Filament\Actions\Exports\Exporter;
use Filament\Actions\Exports\Models\Export;

class ProductionOrderExporter extends Exporter
{
    protected static ?string $model = ProductionOrder::class;

    public static function getColumns(): array
    {
        static $rowNumber = 0;

        return [
            ExportColumn::make('no')
                ->label('NO')
                ->state(function ($record) use (&$rowNumber) {
                    // Increment and return the row number
                    return ++$rowNumber;
                }),
            ExportColumn::make('plant_id')
                ->label('PLANT CODE'),
            ExportColumn::make('item_id')
                ->label('ITEM CODE'),
            ExportColumn::make('quantity')
                ->label('QUANTITY'),
            ExportColumn::make('start_date')
                ->label('START DATE'),
            ExportColumn::make('end_date')
                ->label('END DATE'),
            ExportColumn::make('production_order')
                ->label('PRODUCTION ORDER'),
            ExportColumn::make('from_serial_number')
                ->label('FROM SERIAL NUMBER'),
            ExportColumn::make('to_serial_number')
                ->label('TO SERIAL NUMBER'),
            ExportColumn::make('created_at')
                ->label('CREATED AT'),
            ExportColumn::make('created_by')
                ->label('CREATED BY'),
            ExportColumn::make('updated_at')
                ->label('UPDATED AT')
                ->enabledByDefault(false),
            ExportColumn::make('updated_by')
                ->label('UPDATED BY')
                ->enabledByDefault(false),
            ExportColumn::make('deleted_at')
                ->label('DELETED AT')
                ->enabledByDefault(false),
        ];
    }

    public static function getCompletedNotificationBody(Export $export): string
    {
        $body = 'Your production order export has completed and '.number_format($export->successful_rows).' '.str('row')->plural($export->successful_rows).' exported.';

        if ($failedRowsCount = $export->getFailedRowsCount()) {
            $body .= ' '.number_format($failedRowsCount).' '.str('row')->plural($failedRowsCount).' failed to export.';
        }

        return $body;
    }
}
